/********************************************************************
 *																	*
 * Copyright (c) 2010 Nuvoton Technology Corp. All rights reserved.	*
 *																	*
 ********************************************************************/

#ifndef __VOICE_CHANGE_H__
#define __VOICE_CHANGE_H__
#include "NVTTypes.h"

// --------------------------------------------------------------
// Include Header Files
// --------------------------------------------------------------
#ifdef  __cplusplus
extern "C"
{
#endif

// --------------------------------------------------------------
// Version Definition and Error Code
// --------------------------------------------------------------
#define	VOICE_CHANGE_MAJOR_NUM 1
#define	VOICE_CHANGE_MINOR_NUM 30
#define	VOICE_CHANGE_BUILD_NUM 001
#define VOICE_CHANGE_VERSION_NUM	_SYSINFRA_VERSION(VOICE_CHANGE_MAJOR_NUM, VOICE_CHANGE_MINOR_NUM, VOICE_CHANGE_BUILD_NUM)

typedef enum {
	E_DECAY_TYPE_0_0 	= 0,
	E_DECAY_TYPE_0_0625 = 1,
	E_DECAY_TYPE_0_09375 = 15,
	E_DECAY_TYPE_0_125 	= 2,
	E_DECAY_TYPE_0_140625= 14,
	E_DECAY_TYPE_0_15625= 13,
	E_DECAY_TYPE_0_171875= 16,
	E_DECAY_TYPE_0_1875	= 3,
	E_DECAY_TYPE_0_21875= 17,
	E_DECAY_TYPE_0_25 	= 4,
	E_DECAY_TYPE_0_3125	= 11,
	E_DECAY_TYPE_0_375 	= 5,
	E_DECAY_TYPE_0_4375	= 12,
	E_DECAY_TYPE_0_5 	= 6,
	E_DECAY_TYPE_0_625 	= 7,
	E_DECAY_TYPE_0_75 	= 8,
	E_DECAY_TYPE_0_875 	= 9,
	E_DECAY_TYPE_1_0 	= 10
} E_DECAY_TYPE;


//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
void
VoiceChange_InitMEcho(
	UINT8 u8MEchoNum,
	INT8* pi8MEchoBuf,
	INT32 i32MEchoBufSize,
	E_DECAY_TYPE eDecayType
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_MEchoPc8(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_MEchoPc13(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_MEchoPc16(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_MEchoLp6(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_MEchoPc8NotMix(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_MEchoPc13NotMix(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_MEchoPc16NotMix(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_MEchoLp6NotMix(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
void
VoiceChange_InitEcho(
	INT8* pi8EchoBuf,
	INT16 i16EchoBufSize,
	E_DECAY_TYPE eDecayType
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc8(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc13(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc16(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoLp6(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc8NotMix(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc13NotMix(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc16NotMix(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoLp6NotMix(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
void
VoiceChange_InitEchoEx(
	void *pEcho,
	INT16 i16EchoBufSize,
	E_DECAY_TYPE eDecayType
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc8Ex(
	void *pEcho,
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc13Ex(
	void *pEcho,
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc16Ex(
	void *pEcho,
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoLp6Ex(
	void *pEcho,
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc8ExNotMix(
	void *pEcho,
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc13ExNotMix(
	void *pEcho,
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoPc16ExNotMix(
	void *pEcho,
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_EchoLp6ExNotMix(
	void *pEcho,
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
void
VoiceChange_InitDelay(
	INT8* pi8DelayBuf,
	INT16 i16DelayBufSize,
	E_DECAY_TYPE eDecayType
	);
//-------------------------------------------------------------------------
INT16
VoiceChange_DelayPc8(
	INT16 i16Pcm
	);

//-------------------------------------------------------------------------
INT16
VoiceChange_DelayPc13(
	INT16 i16Pcm
	);

//-------------------------------------------------------------------------
INT16
VoiceChange_DelayPc16(
	INT16 i16Pcm
	);

//-------------------------------------------------------------------------
INT16
VoiceChange_DelayLp6(
	INT16 i16Pcm
	);
//-------------------------------------------------------------------------
INT16
VoiceChange_DelayPc8NotMix(
	INT16 i16Pcm
	);

//-------------------------------------------------------------------------
INT16
VoiceChange_DelayPc13NotMix(
	INT16 i16Pcm
	);

//-------------------------------------------------------------------------
INT16
VoiceChange_DelayLp6NotMix(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
void
VoiceChange_InitChorus(
	INT8* pi8ChorusBuf,
	INT16 i16ChorusBufSize
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_ChorusPc8(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_ChorusPc13(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_ChorusPc16(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_ChorusLp6(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_ChorusPc8NotMix(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_ChorusPc13NotMix(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_ChorusPc16NotMix(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16
VoiceChange_ChorusLp6NotMix(
	INT16 i16Pcm
	);


//---------------------------------------------------------------------------------------------------------
INT16 
VoiceChange_Compander9(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16 
VoiceChange_Compander9B(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16 
VoiceChange_Suppress512(
	INT16 i16Pcm
	);
//---------------------------------------------------------------------------------------------------------
INT16 
VoiceChange_Suppress1024(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16 
VoiceChange_Suppress2048(
	INT16 i16Pcm
	);

//---------------------------------------------------------------------------------------------------------
INT16 
VoiceChange_Suppress4096(
	INT16 i16Pcm
	) ;

//---------------------------------------------------------------------------------------------------------
// Get Subband library version
//---------------------------------------------------------------------------------------------------------
UINT32
VoiceChange_GetVersion(void);

#ifdef  __cplusplus
}
#endif

#endif // __VOICE_CHANGE_H__
