#ifndef FMC_USER_H
#define FMC_USER_H

#include "M451Series.h"

// #define FMC_CONFIG0_ADDR        (FMC_CONFIG_BASE)       /*!< CONFIG 0 Address */
// #define FMC_CONFIG1_ADDR        (FMC_CONFIG_BASE + 4)   /*!< CONFIG 1 Address */

#define Config0         FMC_CONFIG0_ADDR
#define Config1         FMC_CONFIG1_ADDR

#define ISPGO           0x01
#define APROM_BASE      0x00000000
#define PAGE_SIZE       FMC_FLASH_PAGE_SIZE       

/*---------------------------------------------------------------------------------------------------------*/
/* Define parameter                                                                                        */
/*---------------------------------------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------------------------------------*/
/*  FMC Macro Definitions                                                                                  */
/*---------------------------------------------------------------------------------------------------------*/
#define _FMC_ENABLE_CFG_UPDATE()   (FMC->ISPCTL |=  FMC_ISPCTL_CFGUEN_Msk) /*!< Enable CONFIG Update Function  */
#define _FMC_DISABLE_CFG_UPDATE()  (FMC->ISPCTL &= ~FMC_ISPCTL_CFGUEN_Msk) /*!< Disable CONFIG Update Function */


extern int FMC_Write(unsigned int u32Addr, unsigned int u32Data);	  
extern int FMC_Read(unsigned int u32Addr, unsigned int * data);
extern int FMC_Erase(unsigned int u32Addr);
extern void ReadData(unsigned int addr_start, unsigned int addr_end, unsigned int* data);
extern void WriteData(unsigned int addr_start, unsigned int addr_end, unsigned int *data);
                          

#endif

