#ifndef _ISP_H_
#define _ISP_H_

#define FW_VERSION					0x26


//#define SUPPORT_WRITECKSUM
#define USING_AUTODETECT 			// using autodetect for UART download
//#define APPINFO_ON_DATA_FLASH		// must enable data flash and using first page
//#define USING_RS485 				// To do... 
									// default using GPD13 act as Rx/Tx switch for RS485 tranceiver

#define DEBUG_MSG					printf
//#define DEBUG_MSG(...)

//#define TRUE						1
//#define FALSE						0

#define inp32(port)					(*((volatile unsigned int *)(port)))


#define CMD_UPDATE_APROM			0x000000A0
#define CMD_UPDATE_CONFIG			0x000000A1
#define CMD_READ_CONFIG				0x000000A2
#define CMD_ERASE_ALL				0x000000A3
#define CMD_SYNC_PACKNO				0x000000A4
#define CMD_GET_FWVER				0x000000A6
#define CMD_SET_APPINFO     		0x000000A7
#define CMD_GET_APPINFO     		0x000000A8
#define CMD_RUN_APROM				0x000000AB
#define CMD_RUN_LDROM				0x000000AC
#define CMD_RESET					0x000000AD
#define CMD_CONNECT					0x000000AE
#define CMD_DISCONNECT				0x000000AF

#define CMD_GET_DEVICEID			0x000000B1

#define CMD_UPDATE_DATAFLASH 		0x000000C3
#define CMD_WRITE_CHECKSUM 	 		0x000000C9
#define CMD_GET_FLASHMODE 	 		0x000000CA

#define CMD_RESEND_PACKET       	0x000000FF

#define	V6M_AIRCR_VECTKEY_DATA		0x05FA0000UL
#define V6M_AIRCR_SYSRESETREQ		0x00000004UL

#define DISCONNECTED				0
#define CONNECTING					1
#define CONNECTED					2


#define HID_MAX_PACKET_SIZE_EP1		64


typedef void (FUNC_PTR)(void);

extern uint32_t USB_EpAFun(uint8_t *buff);

extern uint8_t  g_USB_INT_OUT_buff[64];

extern uint32_t g_apromSize, g_dataFlashAddr, g_dataFlashSize;
extern volatile uint32_t g_pdid, g_timecnt;
extern volatile int bUartDataReady, bUsingUART;

extern uint32_t GetApromSize(void);
extern int ParseCmd(unsigned char *buffer, uint8_t len, int bUSB);

#endif

