#include <stdio.h>
#include "NUC472_442.h"
#include "FMC_USER.h"
//#include "fmc.h"


#define FMC_ISPCON_ISPFF         (1ul << FMC_ISPCTL_ISPFF_Pos)
#define FMC_ISPCON_LDUEN         (1ul << FMC_ISPCTL_LDUEN_Pos)
#define FMC_ISPCON_CFGUEN        (1ul << FMC_ISPCTL_CFGUEN_Pos)
#define FMC_ISPCON_APUEN         (1ul << FMC_ISPCTL_APUEN_Pos)
#define FMC_ISPCON_BS            (1ul << FMC_ISPCTL_BS_Pos)		
#define FMC_ISPCON_ISPEN         (1ul << FMC_ISPCTL_ISPEN_Pos)



extern uint32_t g_apromSize, g_dataFlashAddr, g_dataFlashSize;


int FMC_Write(unsigned int address, unsigned int data)
{
#if(0)
//    unsigned int Reg;
//    
//    outp32(ISPCMD, ISP_Program);
//    outp32(ISPADDR, address);
//    outp32(ISPDAT, data);
//    outp32(ISPTRG, ISPGO); 
//
//    __ISB();
//    
//    Reg = inp32(FISPCON);
//    if (Reg & ISPFF)
//    {
//    	outp32(FISPCON, Reg);
//    	return -1;
//    }
//    return 0;
#else
//	unsigned int Reg;  

//	outp32(ISPCMD2, FMC_ISPCMD_PROGRAM);  	
//	outp32(ISPADDR2, address);
//	outp32(ISPDAT2, data);
//	outp32(ISPTRG2, 0x1); 
	
    FMC->ISPADDR = address;			     	
	FMC->ISPCMD = FMC_ISPCMD_WRITE;
	FMC->ISPDAT = data;
    FMC->ISPTRG = 0x1;  

#if ISBEN    
    __ISB();
#endif    
//    while(FMC->ISPTRG);

//	Reg = inp32(FISPCON);
//    if (Reg & ISPFF)
//    {
//    	outp32(FISPCON, Reg);
//    	return -1;
//    }
    return 0;
	

#endif
}





int FMC_Read(unsigned int address, unsigned int * data)
{
#if(0)
    unsigned int Reg;

    outp32(ISPCMD2, FMC_ISPCMD_READ);
    outp32(ISPADDR2, address);
    outp32(ISPDAT2, 0x00000000);
	outp32(ISPTRG2, ISPGO); 

    __ISB();

    Reg = inp32(FISPCON);
    
	if(Reg & ISPFF)
    {
    	outp32(FISPCON, Reg);
    	return -1;
    }
 
	*data = inp32(ISPDAT2);

    return 0;
#else
	unsigned int Reg;
//	volatile uint32_t *i32pTmp;	

	FMC->ISPCMD = FMC_ISPCMD_READ;
    FMC->ISPADDR = address;
    FMC->ISPDAT = 0;
    FMC->ISPTRG = 0x1;
#if ISBEN    
    __ISB();
#endif    
//    while (FMC->ISPTRG);    
//    return FMC->ISPDAT;
	
	Reg = inp32(FISPCON);
//	Reg = inp32(&(FMC->ISPCTL));
    	
	if(Reg & ISPFF)
    {
    	outp32(FISPCON, Reg);
    	return -1;
    }

    *data = inp32(&FMC->ISPDAT);
    return 0;
#endif	
	
	
	
}

#if(1)
int FMC_Erase(unsigned int address)
{
 //   unsigned int Reg;
    
//   outp32(ISPCMD, ISP_PageErase);
//   outp32(ISPADDR, address);
//   outp32(ISPTRG, ISPGO); 

	FMC->ISPCMD = ISP_PageErase;
    FMC->ISPADDR = address;
    FMC->ISPTRG = 0x1;



//	__ISB();
    
//    Reg = inp32(FISPCON);
//    if (Reg & ISPFF)
//    {
//    	outp32(FISPCON, Reg);
//    	return -1;
//    }
    return 0;
}
#endif

void ReadData(unsigned int addr_start, unsigned int addr_end, unsigned int* data)    // Read data from flash
{
    unsigned int rLoop;

    for ( rLoop = addr_start; rLoop < addr_end; rLoop += 4 ) 
    {     
		FMC_Read(rLoop, data);
		data++;
    }

    return;
}

void WriteData(unsigned int addr_start, unsigned int addr_end, unsigned int *data)  // Write data into flash
{
    unsigned int wLoop;
    
    for ( wLoop = addr_start; wLoop < addr_end; wLoop+=4 ) 
    {
        FMC_Write(wLoop, *data);
        data++;
    }

}



//bAprom == TRUE erase all aprom besides data flash
void EraseAP(uint8_t bAprom, unsigned int addr_start, unsigned int addr_end)
{
    unsigned int eraseLoop;
    unsigned int erase_end;
    
    if(bAprom == TRUE)
    {
    	//GetDataFlashInfo(&erase_end, &eraseLoop);
    	erase_end = g_dataFlashAddr;
    	eraseLoop = APROM_BASE;
    }
    else
    {
    	eraseLoop = addr_start;
    	erase_end = addr_end;
    }
    
	for(;eraseLoop < erase_end; eraseLoop += PAGE_SIZE )
    {
        FMC_Erase(eraseLoop);
    }           
    return;
}


void UpdateConfig(unsigned int *data, unsigned int *res)
{
		
	//FMC->ISPCON |=  FMC_ISPCON_CFGUEN;//enable config update
    FMC->ISPCTL |=  FMC_ISPCON_CFGUEN;//enable config update
	
	FMC_Erase(Config0);
    //FMC_Write(Config0, 0xFFFFFF7F); // Disable Lock bit
    //FMC_Write(Config1, 0x0001F000);
    
   	FMC_Write(Config0, *data);
   	FMC_Write(Config1, *(data+1));
    
    if(res)
    {
	    FMC_Read(Config0, res);
    	FMC_Read(Config1, res+1);
    }
    
    //FMC->ISPCON &= ~FMC_ISPCON_CFGUEN;//disable config update
	FMC->ISPCTL	&= ~FMC_ISPCON_CFGUEN;//disable config update
}

void GetDataFlashInfo(uint32_t *addr, uint32_t *size)
{
	uint32_t uData;
	
	*size = 0;
	
	if(g_apromSize >= 0x20000)
    {
    	FMC_Read(Config0, &uData);
    	if((uData&0x01) == 0)//DFEN enable
    	{
    		FMC_Read(Config1, &uData);
    		if(uData > g_apromSize || uData < 0x200)//avoid config1 value from error
    			uData = g_apromSize;
    		
    		*addr = uData;
    		*size = g_apromSize - uData;
    	}
    	else
    	{
    		*addr = g_apromSize;
    		*size = 0;
    	}
    }
    else
    {
    	*addr = 0x1F000;
    	*size = 4096;//4K
    }
}
