

#ifndef FMC_USER_H
#define FMC_USER_H

#include "NUC472_442.h"

#define FLASH64K
#undef FMC_BASE
#undef outp32
#undef inp32

#define outp32(port,value)	(*((volatile unsigned int *)(port))=(value))
#define inp32(port)			(*((volatile unsigned int *)(port)))

#define FMC_BASE        0x4000C000//0x5000C000UL		

#define FISPCON        (FMC_BASE+0x000)			

// #define ISPADDR         (FMC_BASE+0x004)		
// #define ISPDAT         (FMC_BASE+0x008)			
// #define ISPCMD         (FMC_BASE+0x00C)			
// #define ISPTRG         (FMC_BASE+0x010)			
// #define DFBADDR        (FMC_BASE+0x014)
// #define FATCON         (FMC_BASE+0x018)			
// #define ICPCON         (FMC_BASE+0x01C)			
// #define RMPCON         (FMC_BASE+0x020)			

#define Config0         0x00300000
#define Config1         0x00300004
#define APROM_BASE      0x00000000
// For LD ROM
//#define LDROM_BASE      0x00100000
//#define LDROM_SIZE      0x00001000
//#define LDROM_END       0x00101000

#define ISPGO           0x01
#define ISPFF           0x00000040
#define PAGE_SIZE       0x00000800 

#define ISP_Read        0x00
#define ISP_Program     0x21
#define ISP_PageErase   0x22


#define BOOL		uint8_t


/*---------------------------------------------------------------------------------------------------------*/
/* Define parameter                                                                                        */
/*---------------------------------------------------------------------------------------------------------*/
//#define PAGE_SIZE                      0x00000200     /* Page size                                         */
//#define PAGE_NUM                       32             /* Total page number                                 */

//#if(0)
//#define FMC_ISPCON_ISPFF         (1ul << FMC_ISPCON_ISPFF_Pos)	  /*!< ISP Fail Flag (Write-protection Bit)       */
//#define FMC_ISPCON_LDUEN         (1ul << FMC_ISPCON_LDUEN_Pos)	  /*!< LDROM Update Enable (Write-protection Bit)      */
//#define FMC_ISPCON_CFGUEN        (1ul << FMC_ISPCON_CFGUEN_Pos)	  /*!< Enable Config-bits Update by ISP (Write-protection Bit)      */
//#define FMC_ISPCON_APUEN         (1ul << FMC_ISPCON_APUEN_Pos)	  /*!< APROM Update Enable (Write-protection Bit)  */
//#define FMC_ISPCON_BS            (1ul << FMC_ISPCON_BS_Pos)		  /*!< Boot Select (Write-protection Bit)       */
//#define FMC_ISPCON_ISPEN         (1ul << FMC_ISPCON_ISPEN_Pos)	  /*!< ISP Enable (Write-protection Bit)      */
//#endif

//#define FMC_ISPCON_ISPFF         (1ul << FMC_ISPCTL_ISPFF_Pos)	  /*!< ISP Fail Flag (Write-protection Bit)       */
//#define FMC_ISPCON_LDUEN         (1ul << FMC_ISPCTL_LDUEN_Pos)	  /*!< LDROM Update Enable (Write-protection Bit)      */
//#define FMC_ISPCON_CFGUEN        (1ul << FMC_ISPCTL_CFGUEN_Pos)	  /*!< Enable Config-bits Update by ISP (Write-protection Bit)      */
//#define FMC_ISPCON_APUEN         (1ul << FMC_ISPCTL_APUEN_Pos)	  /*!< APROM Update Enable (Write-protection Bit)  */
//#define FMC_ISPCON_BS            (1ul << FMC_ISPCTL_BS_Pos)		  /*!< Boot Select (Write-protection Bit)       */
//#define FMC_ISPCON_ISPEN         (1ul << FMC_ISPCTL_ISPEN_Pos)	  /*!< ISP Enable (Write-protection Bit)      */


extern void EraseAP(BOOL bAprom, unsigned int addr_start, unsigned int addr_end);
extern void ReadData(unsigned int addr_start, unsigned int addr_end, unsigned int* data);
extern void WriteData(unsigned int addr_start, unsigned int addr_end, unsigned int *data);
extern void UpdateConfig(unsigned int *data, unsigned int *res);
extern void GetDataFlashInfo(uint32_t *addr, uint32_t *size);
// extern int FMC_Read(unsigned int address, unsigned int * data);
// extern int FMC_Write(unsigned int address, unsigned int data);	  
// extern int FMC_Erase(unsigned int address);
// extern void GetDataFlashInfo(uint32_t *addr, uint32_t *size);

#endif

